Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 61919 - /etc/init.d/serial references '/sbin/setserial' instead of '/bin/setserial' (with patch)
Summary: /etc/init.d/serial references '/sbin/setserial' instead of '/bin/setserial' (...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] baselayout (show other bugs)
Hardware: All Linux
: High normal (vote)
Assignee: Gentoo's Team for Core System packages
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2004-08-27 06:46 UTC by Albert den Haan (at work)
Modified: 2004-08-27 12:39 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Albert den Haan (at work) 2004-08-27 06:46:18 UTC
Tne init script /etc/init.d/serial (from sys-apps/base-layout) refers to '/sbin/setserial' but sys-apps/setserial puts that utility in /bin/.

This affects all attempts to use the initscript to set up serial ports that are not autodetected (i.e. PC/104 ISA serial cards)

SUGGESTED FIX: Changing 'sbin' to 'bin' in the reference to setserial makes the system work as I expect.

diff -u ~/etc_init.d_serial-orig /etc/init.d/serial 
--- /root/etc_init.d_serial-orig        2004-08-31 05:37:37.000000000 -0400
+++ /etc/init.d/serial  2004-08-31 05:13:19.000000000 -0400
@@ -51,7 +51,7 @@
                return
        fi
 
-       SETSERIAL="/sbin/setserial"
+       SETSERIAL="/bin/setserial"
 
        no_errs=1
        done=""


ANOTHER FIX: move the setserial utility (back?) so /sbin

Reproducible: Always
Steps to Reproduce:
1. Install gentoo with the sys-apps/setserial package
2. Put hardware specific configuration bash 'setports()' function in /etc/rc.d/config/serial (included below in "Additional Information")
3. run the /etc/init.d/serial initscript with 'start' or 'restart' as the operation parameter

Actual Results:  
 * WARNING:  you are stopping a boot service.                                    
 * Setting /dev/tts/2.../sbin/runscript.sh: line 31: /sbin/setserial: No such 
fi 
le or directory                                                                  
 * Error setting serial port tts/2 to irq 10 port 0x150 (args: uart 16654)       
  [ !! ]                                                                         
                                                                                 
 * Setting /dev/tts/3.../sbin/runscript.sh: line 31: /sbin/setserial: No such 
fi 
le or directory                                                                  
 * Error setting serial port tts/3 to irq 10 port 0x158 (args: uart 16654)       
  [ !! ]                                                                         
                                                                                 
 * Setting /dev/tts/4.../sbin/runscript.sh: line 31: /sbin/setserial: No such 
fi 
le or directory                                                                  
 * Error setting serial port tts/4 to irq 10 port 0x160 (args: uart 16654)       
  [ !! ]                                                                         
                                                                                 
 * Setting /dev/tts/5.../sbin/runscript.sh: line 31: /sbin/setserial: No such 
fi 
le or directory                                                                  
 * Error setting serial port tts/5 to irq 10 port 0x168 (args: uart 16654)       
  [ !! ]                                                                         
                                                                                 
 * Setting /dev/tts/6.../sbin/runscript.sh: line 31: /sbin/setserial: No such 
fi 
le or directory                                                                  
 * Error setting serial port tts/6 to irq 10 port 0x170 (args: uart 16654)       
  [ !! ]                                                                         
                                                                                 
 * Setting /dev/tts/7.../sbin/runscript.sh: line 31: /sbin/setserial: No such 
fi 
le or directory                                                                  
 * Error setting serial port tts/7 to irq 10 port 0x178 (args: uart 16654)       
  [ !! ]                                                                         
                                                                                 
 * Setting /dev/tts/8.../sbin/runscript.sh: line 31: /sbin/setserial: No such 
fi 
le or directory                                                                  
 * Error setting serial port tts/8 to irq 10 port 0x180 (args: uart 16654)       
  [ !! ]                                                                         
                                                                                 
 * Setting /dev/tts/9.../sbin/runscript.sh: line 31: /sbin/setserial: No such 
fi 
le or directory                                                                  
 * Error setting serial port tts/9 to irq 10 port 0x188 (args: uart 16654)       
  [ !! ]                                                                         
                                                                                 
Cannot get multiport config: Input/output error    

Expected Results:  
 * Setting /dev/tts/2...                                                  
[ ok ] 
 * Setting /dev/tts/3...                                                  
[ ok ] 
 * Setting /dev/tts/4...                                                  
[ ok ] 
 * Setting /dev/tts/5...                                                  
[ ok ] 
 * Setting /dev/tts/6...                                                  
[ ok ] 
 * Setting /dev/tts/7...                                                  
[ ok ] 
 * Setting /dev/tts/8...                                                  
[ ok ] 
 * Setting /dev/tts/9...                                                  
[ ok ] 
 

root # cat /etc/rc.d/config/serial  
#!/etc/init.d/serial 
# $Id: serial,v 1.2 2004/06/10 15:46:09 albert Exp $ 
# setup serial ports on a Xstream/104 "dumb" multiplot serial card 
 
setports () { 
        # assure that the device nodes exist 
        [ -e /dev/tts/2 ] || mknod -m ug+rw /dev/tts/2 c 4 66 
        [ -e /dev/tts/3 ] || mknod -m ug+rw /dev/tts/3 c 4 67 
        [ -e /dev/tts/4 ] || mknod -m ug+rw /dev/tts/4 c 4 68 
        [ -e /dev/tts/5 ] || mknod -m ug+rw /dev/tts/5 c 4 69 
        [ -e /dev/tts/6 ] || mknod -m ug+rw /dev/tts/6 c 4 70 
        [ -e /dev/tts/7 ] || mknod -m ug+rw /dev/tts/7 c 4 71 
        [ -e /dev/tts/8 ] || mknod -m ug+rw /dev/tts/8 c 4 72 
        [ -e /dev/tts/9 ] || mknod -m ug+rw /dev/tts/9 c 4 73 
        chown root:tty /dev/tts/[2-9] 
 
        # tell the kernel where the ports are. 
        setport tts/2 10 0x150 "uart 16654" 
        setport tts/3 10 0x158 "uart 16654" 
        setport tts/4 10 0x160 "uart 16654" 
        setport tts/5 10 0x168 "uart 16654" 
        setport tts/6 10 0x170 "uart 16654" 
        setport tts/7 10 0x178 "uart 16654" 
        setport tts/8 10 0x180 "uart 16654" 
        setport tts/9 10 0x188 "uart 16654" 
 
        # tell the kernel it has a multiport card with a mask ioport. 
        setserial /dev/tts/2 set_multiport port1 0x190 mask1 0xff match1 0 
 
        # tell devfsd there are some new device nodes to consider 
        killall -HUP devfsd 
}
Comment 1 SpanKY gentoo-dev 2004-08-27 12:38:52 UTC
ii dont know what ver of setserial you have but this has already been fixed in cvs
Comment 2 SpanKY gentoo-dev 2004-08-27 12:39:07 UTC
err, version of baselayout, not setserial